/// <reference types="angular" />
/// <reference types="angular-animate" />
/// <reference types="angular-translate" />
/*!
 * MiracleDevs.Angular v1.0.0
 * Copyright (c) 2017 Miracle Devs, Inc
 * Licensed under MIT (https://github.com/MiracleDevs/MiracleDevs.Angular/blob/master/LICENSE)
 */
import { IHttpProvider, IModule as IAngularModule, ILocationProvider, IScope, auto, translate } from 'angular';
import { StateProvider, UrlRouterProvider, StateService } from '@uirouter/angularjs';
import { ILoggingService } from './services/logging.service.interface';
import { IModule } from './module.interface';
export declare abstract class ModuleBase implements IModule {
    protected httpProvider: IHttpProvider;
    protected stateProvider: StateProvider;
    protected interceptorsQueue: Array<Function>;
    protected controllersQueue: Array<Function>;
    protected module: IAngularModule;
    protected logger: ILoggingService;
    constructor();
    getModule(): IAngularModule;
    getModuleName(): string;
    registerControllers(controllers: Function[]): void;
    registerController(controller: Function): void;
    registerServices(services: Function[]): void;
    registerService(service: Function): void;
    registerLoggingService(service: Function): void;
    registerInterceptors(interceptors: Function[]): void;
    registerInterceptor(interceptor: Function): void;
    registerFilters(filters: Function[]): void;
    registerFilter(filter: Function): void;
    registerDirectives(directives: Function[]): void;
    registerDirective(directive: Function): void;
    private registerStates(stateProvider);
    private registerInterceptorsInternally(httpProvider);
    private registerControllerState(controller);
    protected configureRoutes(stateProvider: StateProvider, urlRouterProvider: UrlRouterProvider, httpProvider: IHttpProvider, locationProvider: ILocationProvider): void;
    protected authorizeRoute(rootScope: IScope, state: StateService, injector: auto.IInjectorService): void;
    protected configureTranslator(translateProvider: translate.ITranslateProvider): void;
    protected getModuleDependencies(): Array<string>;
    protected register(): void;
}
