/// <reference types="angular" />
/*!
 * MiracleDevs.Angular v1.0.0
 * Copyright (c) 2017 Miracle Devs, Inc
 * Licensed under MIT (https://github.com/MiracleDevs/MiracleDevs.Angular/blob/master/LICENSE)
 */
import { IScope, auto, IPromise, IController as AngularController } from "angular";
import { IAlertService } from "../services/alert.service.interface";
import { StateService, StateObject } from "@uirouter/angularjs";
import { ILoggingService } from "../services/logging.service.interface";
import { IModalInstance } from "../services/modal.service.interface";
export declare abstract class ControllerBase implements AngularController {
    protected scope: IScope;
    protected injector: auto.IInjectorService;
    protected alertService: IAlertService;
    protected stateService: StateService;
    protected logger: ILoggingService;
    protected constructor(scope: IScope, injector: auto.IInjectorService);
    protected dispose(): void;
    protected getService<T>(service: string): T;
    protected open(controller: Function, parameters?: any, staticDialog?: boolean, keyboard?: boolean): IModalInstance;
    protected call<T>(call: () => IPromise<T>, success?: (result: T) => void, loading?: (loading: boolean) => void, fail?: (reason: any) => void): void;
    protected showErrors(messages: string[]): void;
    protected showWarnings(messages: string[]): void;
    protected showError(message: string): void;
    protected showWarning(message: string): void;
    protected showMessage(message: string): void;
    protected handleException(ex: any): void;
    protected changeState(state: string, params?: any, reload?: boolean): Promise<StateObject>;
}
