"use strict";
/*!
 * MiracleDevs.Angular v1.0.0
 * Copyright (c) 2017 Miracle Devs, Inc
 * Licensed under MIT (https://github.com/MiracleDevs/MiracleDevs.Angular/blob/master/LICENSE)
 */
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
Object.defineProperty(exports, "__esModule", { value: true });
var directive_1 = require("../decorators/directive");
var base_directive_1 = require("./base.directive");
var paradigm_ui_web_shared_1 = require("@miracledevs/paradigm-ui-web-shared");
var CommentArea = /** @class */ (function (_super) {
    __extends(CommentArea, _super);
    function CommentArea() {
        var _this = _super !== null && _super.apply(this, arguments) || this;
        _this.restrict = "A";
        _this.scope = {
            ngModel: "="
        };
        return _this;
    }
    CommentArea_1 = CommentArea;
    CommentArea.prototype.create = function (scope, instanceElement, instanceAttributes, controller, transclude) {
        var _this = this;
        var options = {};
        this.tryGetNumber(options, instanceAttributes, "defaultHeight");
        this.tryGetNumber(options, instanceAttributes, "maxSize");
        this.tryGet(options, instanceAttributes, "maxSizeField");
        this.tryGet(options, instanceAttributes, "maxSizeText");
        this.tryGetBoolean(options, instanceAttributes, "resize");
        this.tryGetBoolean(options, instanceAttributes, "showAlways");
        this.tryGetBoolean(options, instanceAttributes, "restrictEntry");
        this.tryGet(options, instanceAttributes, "negativeClass");
        if (options.restrictEntry) {
            instanceElement.on("keydown", function (event) { return _this.restrictEntry(event, options, instanceElement, false); });
            instanceElement.on("keypress", function (event) { return _this.restrictEntry(event, options, instanceElement, true); });
            instanceElement.on("keyup", function (event) { return _this.restrictEntry(event, options, instanceElement, false); });
            scope.$watch(function () { return scope["ngModel"]; }, function () { return _this.restrictEntry(null, options, instanceElement, false); });
        }
        else {
            instanceElement.on("keypress", function () { return _this.showCharacterLeft(options, instanceElement, true); });
            scope.$watch(function () { return scope["ngModel"]; }, function () { return _this.showCharacterLeft(options, instanceElement, false); });
        }
    };
    CommentArea.prototype.restrictEntry = function (event, options, element, cancel) {
        if (!paradigm_ui_web_shared_1.ObjectExtensions.isNull(options.maxSize)) {
            var value = element.val();
            var length_1 = value.length;
            var available = options.maxSize - length_1;
            if (available < 0)
                available = -1;
            if (available === -1) {
                if (cancel) {
                    event.stopPropagation();
                    event.preventDefault();
                }
                element.val(value.substr(0, options.maxSize));
                available = 0;
            }
            if (!paradigm_ui_web_shared_1.ObjectExtensions.isNull(options.maxSizeText)) {
                $(options.maxSizeField).text((available === options.maxSize && !options.showAlways) ? "" : paradigm_ui_web_shared_1.StringExtensions.format(options.maxSizeText, available));
            }
            if (!paradigm_ui_web_shared_1.ObjectExtensions.isNull(options.resize) && options.resize) {
                this.checkSize(options, element);
            }
        }
    };
    CommentArea.prototype.showCharacterLeft = function (options, element, cancel) {
        if (!paradigm_ui_web_shared_1.ObjectExtensions.isNull(options.maxSize)) {
            var value = element.val();
            var length_2 = value.length;
            var available = options.maxSize - length_2;
            if (!paradigm_ui_web_shared_1.ObjectExtensions.isNull(options.maxSizeText)) {
                var field = $(options.maxSizeField);
                if (!paradigm_ui_web_shared_1.ObjectExtensions.isNull(options.negativeClass)) {
                    if (available < 0)
                        field.addClass(options.negativeClass);
                    else
                        field.removeClass(options.negativeClass);
                }
                $(options.maxSizeField).text((available === options.maxSize && !options.showAlways) ? "" : paradigm_ui_web_shared_1.StringExtensions.format(options.maxSizeText, available));
            }
            if (!paradigm_ui_web_shared_1.ObjectExtensions.isNull(options.resize) && options.resize) {
                this.checkSize(options, element);
            }
        }
        else {
            if (!paradigm_ui_web_shared_1.ObjectExtensions.isNull(options.resize) && options.resize) {
                this.checkSize(options, element);
            }
        }
    };
    CommentArea.prototype.checkSize = function (options, element) {
        var control = element[0];
        var defaultHeight = options.defaultHeight || 0;
        control.style.height = "1px";
        if (control.scrollHeight > control.clientHeight) {
            if (control.scrollHeight > defaultHeight)
                control.style.height = control.scrollHeight + "px";
            else
                control.style.height = defaultHeight + "px";
        }
        else if (!paradigm_ui_web_shared_1.ObjectExtensions.isNull(options.defaultHeight)) {
            control.style.height = defaultHeight + "px";
        }
    };
    CommentArea.factory = function () {
        return new CommentArea_1();
    };
    CommentArea = CommentArea_1 = __decorate([
        directive_1.Directive({
            name: "commentArea",
            factory: CommentArea_1.factory
        })
    ], CommentArea);
    return CommentArea;
    var CommentArea_1;
}(base_directive_1.DirectiveBase));
exports.CommentArea = CommentArea;
