"use strict";
/*!
 * MiracleDevs.Angular v1.0.0
 * Copyright (c) 2017 Miracle Devs, Inc
 * Licensed under MIT (https://github.com/MiracleDevs/MiracleDevs.Angular/blob/master/LICENSE)
 */
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
Object.defineProperty(exports, "__esModule", { value: true });
var base_directive_1 = require("./base.directive");
var directive_1 = require("../decorators/directive");
var paradigm_ui_web_shared_1 = require("@miracledevs/paradigm-ui-web-shared");
var DateTimePicker = /** @class */ (function (_super) {
    __extends(DateTimePicker, _super);
    function DateTimePicker(filter) {
        var _this = _super.call(this) || this;
        _this.filter = filter;
        _this.restrict = "A";
        _this.require = "ngModel";
        return _this;
    }
    DateTimePicker_1 = DateTimePicker;
    DateTimePicker.prototype.create = function (scope, instanceElement, instanceAttributes, controller, transclude) {
        var _this = this;
        var options = {};
        //////////////////////////////////////////////////////////////////
        // Own properties
        //////////////////////////////////////////////////////////////////
        this.tryGet(options, instanceAttributes, "format");
        this.tryGet(options, instanceAttributes, "dayViewHeaderFormat");
        this.tryGetBoolean(options, instanceAttributes, "extraFormats");
        this.tryGetNumber(options, instanceAttributes, "stepping");
        this.tryGetDate(options, instanceAttributes, "minDate");
        this.tryGetDate(options, instanceAttributes, "maxDate");
        this.tryGetBoolean(options, instanceAttributes, "useCurrent");
        this.tryGetBoolean(options, instanceAttributes, "collapse");
        this.tryGet(options, instanceAttributes, "locale");
        this.tryGet(options, instanceAttributes, "viewMode");
        this.tryGetDate(options, instanceAttributes, "defaultDate");
        this.tryGetBoolean(options, instanceAttributes, "disabledDates");
        this.tryGetBoolean(options, instanceAttributes, "enabledDates");
        this.tryGetBoolean(options, instanceAttributes, "disabledHours");
        this.tryGetBoolean(options, instanceAttributes, "disabledTimeIntervals");
        this.tryGetBoolean(options, instanceAttributes, "useStrict");
        this.tryGetBoolean(options, instanceAttributes, "sideBySide");
        this.tryGetBoolean(options, instanceAttributes, "calendarWeeks");
        this.tryGet(options, instanceAttributes, "toolbarPlacement");
        this.tryGetBoolean(options, instanceAttributes, "showTodayButton");
        this.tryGetBoolean(options, instanceAttributes, "showClear");
        this.tryGetBoolean(options, instanceAttributes, "showClose");
        this.tryGetBoolean(options, instanceAttributes, "keepOpen");
        this.tryGetBoolean(options, instanceAttributes, "allowInputToggle");
        this.tryGetBoolean(options, instanceAttributes, "focusOnShow");
        if (!paradigm_ui_web_shared_1.ObjectExtensions.isNull(instanceAttributes["maxDateToday"]))
            options.maxDate = new Date();
        instanceElement["datetimepicker"](options);
        instanceElement.on("dp.change", function (e) {
            if (paradigm_ui_web_shared_1.ObjectExtensions.isNull(options.format) || options.format === "L")
                controller.$setViewValue(!paradigm_ui_web_shared_1.ObjectExtensions.isNull(e["date"])
                    ? _this.filter("date")(e["date"]._d, "MM/dd/yyyy")
                    : null);
            if (!paradigm_ui_web_shared_1.ObjectExtensions.isNull(options.format) && options.format === "LT")
                controller.$setViewValue(!paradigm_ui_web_shared_1.ObjectExtensions.isNull(e["date"])
                    ? _this.filter("date")(e["date"]._d, "hh:mm")
                    : null);
        });
        instanceElement.on("dp.show", function () {
            if (!paradigm_ui_web_shared_1.ObjectExtensions.isNull(options.viewMode)) {
                instanceElement.data("DateTimePicker").viewMode(options.viewMode);
            }
        });
    };
    DateTimePicker.factory = function (filter) {
        return new DateTimePicker_1(filter);
    };
    DateTimePicker = DateTimePicker_1 = __decorate([
        directive_1.Directive({
            name: "dateTimePicker",
            factory: DateTimePicker_1.factory,
            dependencies: ["$filter"]
        })
    ], DateTimePicker);
    return DateTimePicker;
    var DateTimePicker_1;
}(base_directive_1.DirectiveBase));
exports.DateTimePicker = DateTimePicker;
