"use strict";
/*!
 * MiracleDevs.Angular v1.0.0
 * Copyright (c) 2017 Miracle Devs, Inc
 * Licensed under MIT (https://github.com/MiracleDevs/MiracleDevs.Angular/blob/master/LICENSE)
 */
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
Object.defineProperty(exports, "__esModule", { value: true });
var angular_service_1 = require("../services/angular.service");
var directive_1 = require("../decorators/directive");
var base_directive_1 = require("./base.directive");
var paradigm_ui_web_shared_1 = require("@miracledevs/paradigm-ui-web-shared");
var FileButton = /** @class */ (function (_super) {
    __extends(FileButton, _super);
    function FileButton(timeout) {
        var _this = _super.call(this) || this;
        _this.restrict = "E";
        _this.scope = {
            title: "@",
            ariaLabel: "@",
            accept: "@",
            caption: "@",
            cssClass: "@",
            fileSelected: "&"
        };
        _this.template = '<input type="file" style="display: none" title="{{title}}" accept="{{accept}}" aria-label="{{ariaLabel}}" />' +
            '<button type="button" class="{{cssClass}}">{{caption}}</button>';
        _this.timeout = timeout;
        return _this;
    }
    FileButton_1 = FileButton;
    FileButton.prototype.create = function (scope, instanceElement, instanceAttributes, controller, transclude) {
        var _this = this;
        var button = instanceElement.find("button");
        var file = instanceElement.find("input");
        button.on("click", function () { return file.trigger("click"); });
        file.on("change", function (e) {
            _this.timeout(function () {
                if (paradigm_ui_web_shared_1.ObjectExtensions.isNull(e) || paradigm_ui_web_shared_1.ObjectExtensions.isNull(e.target) || paradigm_ui_web_shared_1.ObjectExtensions.isNull(e.target["files"]))
                    return;
                scope["fileSelected"]({ files: e.target["files"] });
            });
        });
    };
    FileButton.factory = function (timeout) {
        return new FileButton_1(timeout);
    };
    FileButton = FileButton_1 = __decorate([
        directive_1.Directive({
            name: "fileButton",
            factory: FileButton_1.factory,
            dependencies: [angular_service_1.AngularServices.timeout]
        })
    ], FileButton);
    return FileButton;
    var FileButton_1;
}(base_directive_1.DirectiveBase));
exports.FileButton = FileButton;
