"use strict";
/*!
 * MiracleDevs.Angular v1.0.0
 * Copyright (c) 2017 Miracle Devs, Inc
 * Licensed under MIT (https://github.com/MiracleDevs/MiracleDevs.Angular/blob/master/LICENSE)
 */
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
Object.defineProperty(exports, "__esModule", { value: true });
var base_directive_1 = require("./base.directive");
var directive_1 = require("../decorators/directive");
var FileDragAndDrop = /** @class */ (function (_super) {
    __extends(FileDragAndDrop, _super);
    function FileDragAndDrop() {
        var _this = _super !== null && _super.apply(this, arguments) || this;
        _this.restrict = "A";
        return _this;
    }
    FileDragAndDrop_1 = FileDragAndDrop;
    FileDragAndDrop.prototype.create = function (scope, instanceElement, instanceAttributes, controller, transclude) {
        instanceElement[0].addEventListener("dragenter", function () { return instanceElement.addClass("file-drag-enter"); }, false);
        instanceElement[0].addEventListener("dragexit", function () { return instanceElement.removeClass("file-drag-enter"); }, false);
        instanceElement[0].addEventListener("dragend", function () { return instanceElement.removeClass("file-drag-enter"); }, false);
        instanceElement[0].addEventListener("dragleave", function () { return instanceElement.removeClass("file-drag-enter"); }, false);
        instanceElement[0].addEventListener("dragover", function (e) {
            instanceElement.addClass("file-drag-enter");
            e.dataTransfer.dropEffect = "copy";
            e.stopPropagation();
            e.preventDefault();
        }, false);
        instanceElement[0].addEventListener("drop", function (e) {
            scope.$eval(instanceAttributes["fileSelected"], { files: e.dataTransfer.files });
            instanceElement.removeClass("file-drag-enter");
            e.stopPropagation();
            e.preventDefault();
        }, false);
    };
    FileDragAndDrop.factory = function () {
        return new FileDragAndDrop_1();
    };
    FileDragAndDrop = FileDragAndDrop_1 = __decorate([
        directive_1.Directive({
            name: "fileDragAndDrop",
            factory: FileDragAndDrop_1.factory
        })
    ], FileDragAndDrop);
    return FileDragAndDrop;
    var FileDragAndDrop_1;
}(base_directive_1.DirectiveBase));
exports.FileDragAndDrop = FileDragAndDrop;
