/// <reference types="angular" />
/*!
 * MiracleDevs.Angular v1.0.0
 * Copyright (c) 2017 Miracle Devs, Inc
 * Licensed under MIT (https://github.com/MiracleDevs/MiracleDevs.Angular/blob/master/LICENSE)
 */
import { DirectiveBase } from "./base.directive";
import { IInterpolateService, IScope, IAttributes, IController, ITranscludeFunction } from "angular";
export declare class HorizontalScroller extends DirectiveBase {
    private interpolate;
    restrict: string;
    constructor(interpolate: IInterpolateService);
    protected create(scope: IScope, instanceElement: JQuery, instanceAttributes: IAttributes, controller: IController, transclude: ITranscludeFunction): void;
    protected dispose(scope: IScope, instanceElement: JQuery, instanceAttributes: IAttributes, controller: IController, transclude: ITranscludeFunction): void;
    static factory(interpolate: IInterpolateService): HorizontalScroller;
}
export interface IHorizontalScrollerParameters {
    element: JQuery;
    container: string;
    content: string;
    leftArrow: string;
    rightArrow: string;
    speed: number;
    friction: number;
    minVelocity: number;
    fps: number;
}
export declare class HorizontalScrollerInstance {
    element: JQuery;
    container: JQuery;
    content: JQuery;
    leftArrow: JQuery;
    rightArrow: JQuery;
    position: number;
    velocity: number;
    speed: number;
    friction: number;
    pressing: boolean;
    direction: number;
    millisecondsPerFrame: number;
    minVelocity: number;
    intervalId: number;
    lastTime: number;
    constructor(options: IHorizontalScrollerParameters);
    enableScroll(): void;
    private applyPosition();
    private checkConstraints();
    private killInterval();
    private getMilliseconds();
    private moveLeft();
    private moveRight();
    private move();
    dispose(): void;
}
