/// <reference types="angular" />
/*!
 * MiracleDevs.Angular v1.0.0
 * Copyright (c) 2017 Miracle Devs, Inc
 * Licensed under MIT (https://github.com/MiracleDevs/MiracleDevs.Angular/blob/master/LICENSE)
 */
import { DirectiveBase } from "./base.directive";
import { IKeyProcessorService } from "../services/key-processor.service.interface";
import { IAttributes, IController, ITranscludeFunction, IScope } from "angular";
export declare class KeyboardListener extends DirectiveBase {
    private keyProcessor;
    restrict: string;
    scope: {
        disabled: string;
        attachTo: string;
    };
    constructor(keyProcessor: IKeyProcessorService);
    protected create(scope: IKeyboardListenerScope, instanceElement: JQuery, instanceAttributes: IAttributes, controller: IController, transclude: ITranscludeFunction): void;
    protected dispose(scope: IKeyboardListenerScope, instanceElement: JQuery, instanceAttributes: IAttributes, controller: IController, transclude: ITranscludeFunction): void;
    static factory(keyProcessor: IKeyProcessorService): KeyboardListener;
}
export interface IKeyboardListenerScope extends IScope {
    disabled: boolean;
    attachTo: string;
    $parent: IScope;
}
