"use strict";
/*!
 * MiracleDevs.Angular v1.0.0
 * Copyright (c) 2017 Miracle Devs, Inc
 * Licensed under MIT (https://github.com/MiracleDevs/MiracleDevs.Angular/blob/master/LICENSE)
 */
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
Object.defineProperty(exports, "__esModule", { value: true });
var directive_1 = require("../decorators/directive");
var framework_service_1 = require("../services/framework.service");
var base_directive_1 = require("./base.directive");
var KeyboardListener = /** @class */ (function (_super) {
    __extends(KeyboardListener, _super);
    function KeyboardListener(keyProcessor) {
        var _this = _super.call(this) || this;
        _this.keyProcessor = keyProcessor;
        _this.restrict = "E";
        _this.scope = {
            disabled: "=",
            attachTo: "@"
        };
        return _this;
    }
    KeyboardListener_1 = KeyboardListener;
    KeyboardListener.prototype.create = function (scope, instanceElement, instanceAttributes, controller, transclude) {
        var actions = "";
        var attachTo = $(scope.attachTo || document);
        instanceElement.find("listener").each(function (index, element) {
            actions += element.getAttribute("action") + "|";
        });
        if (actions[actions.length - 1] === "|")
            actions = actions.substr(0, actions.length - 1);
        var keyActions = this.keyProcessor.parseActions(actions);
        var keyProcessor = this.keyProcessor;
        function evaluateKeyPress(e) {
            if (scope.disabled)
                return;
            keyProcessor.evaluateKeyActions(keyActions, "keypress", scope.$parent, e);
        }
        function evaluateKeyDown(e) {
            if (scope.disabled)
                return;
            keyProcessor.evaluateKeyActions(keyActions, "keydown", scope.$parent, e);
        }
        function evaluateKeyUp(e) {
            if (scope.disabled)
                return;
            keyProcessor.evaluateKeyActions(keyActions, "keyup", scope.$parent, e);
        }
        if (keyActions.any(function (x) { return x.eventType === "keypress"; }))
            attachTo.on("keypress.documentKeyboard", evaluateKeyPress);
        if (keyActions.any(function (x) { return x.eventType === "keydown"; }))
            attachTo.on("keydown.documentKeyboard", evaluateKeyDown);
        if (keyActions.any(function (x) { return x.eventType === "keyup"; }))
            attachTo.on("keyup.documentKeyboard", evaluateKeyUp);
    };
    KeyboardListener.prototype.dispose = function (scope, instanceElement, instanceAttributes, controller, transclude) {
        var attachTo = $(scope.attachTo || document);
        attachTo.off("keypress.documentKeyboard");
        attachTo.off("keydown.documentKeyboard");
        attachTo.off("keyup.documentKeyboard");
        _super.prototype.dispose.call(this, scope, instanceElement, instanceAttributes, controller, transclude);
    };
    KeyboardListener.factory = function (keyProcessor) {
        return new KeyboardListener_1(keyProcessor);
    };
    KeyboardListener = KeyboardListener_1 = __decorate([
        directive_1.Directive({
            name: "keyboardListener",
            factory: KeyboardListener_1.factory,
            dependencies: [framework_service_1.FrameworkServices.keyProcessorService]
        })
    ], KeyboardListener);
    return KeyboardListener;
    var KeyboardListener_1;
}(base_directive_1.DirectiveBase));
exports.KeyboardListener = KeyboardListener;
