"use strict";
/*!
 * MiracleDevs.Angular v1.0.0
 * Copyright (c) 2017 Miracle Devs, Inc
 * Licensed under MIT (https://github.com/MiracleDevs/MiracleDevs.Angular/blob/master/LICENSE)
 */
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
Object.defineProperty(exports, "__esModule", { value: true });
var angular_service_1 = require("../services/angular.service");
var directive_1 = require("../decorators/directive");
var base_directive_1 = require("./base.directive");
var paradigm_ui_web_shared_1 = require("@miracledevs/paradigm-ui-web-shared");
var MdUiSrefActive = /** @class */ (function (_super) {
    __extends(MdUiSrefActive, _super);
    function MdUiSrefActive(interpolate, state, transitions) {
        var _this = _super.call(this) || this;
        _this.interpolate = interpolate;
        _this.state = state;
        _this.transitions = transitions;
        _this.restrict = "A";
        return _this;
    }
    MdUiSrefActive_1 = MdUiSrefActive;
    MdUiSrefActive.prototype.create = function (scope, instanceElement, instanceAttributes, controller, transclude) {
        var _this = this;
        var cssClass = instanceAttributes["mdUiSrefActive"];
        var state = this.interpolate(instanceAttributes["mdUiSref"] || instanceAttributes["uiSref"])(scope);
        function update(toState) {
            if (paradigm_ui_web_shared_1.ObjectExtensions.isNull(toState) || paradigm_ui_web_shared_1.ObjectExtensions.isNull(toState.name))
                return;
            if (toState.name.indexOf(state) !== -1) {
                instanceElement.addClass(cssClass);
            }
            else {
                instanceElement.removeClass(cssClass);
            }
        }
        update(this.state.current);
        instanceElement["transition-event"] = this.transitions.onSuccess({}, function () {
            update(_this.state.current);
        });
    };
    MdUiSrefActive.prototype.dispose = function (scope, instanceElement, instanceAttributes, controller, transclude) {
        var hookOff = instanceElement["transition-event"];
        if (!paradigm_ui_web_shared_1.ObjectExtensions.isNull(hookOff)) {
            instanceElement["transition-event"]();
            instanceElement["transition-event"] = null;
        }
        _super.prototype.dispose.call(this, scope, instanceElement, instanceAttributes, controller, transclude);
    };
    MdUiSrefActive.factory = function (interpolate, state, transitions) {
        return new MdUiSrefActive_1(interpolate, state, transitions);
    };
    MdUiSrefActive = MdUiSrefActive_1 = __decorate([
        directive_1.Directive({
            name: "mdUiSrefActive",
            factory: MdUiSrefActive_1.factory,
            dependencies: [angular_service_1.AngularServices.interpolate, angular_service_1.AngularServices.state, angular_service_1.AngularServices.transitions]
        })
    ], MdUiSrefActive);
    return MdUiSrefActive;
    var MdUiSrefActive_1;
}(base_directive_1.DirectiveBase));
exports.MdUiSrefActive = MdUiSrefActive;
