"use strict";
/*!
 * MiracleDevs.Angular v1.0.0
 * Copyright (c) 2017 Miracle Devs, Inc
 * Licensed under MIT (https://github.com/MiracleDevs/MiracleDevs.Angular/blob/master/LICENSE)
 */
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
Object.defineProperty(exports, "__esModule", { value: true });
var directive_1 = require("../decorators/directive");
var framework_service_1 = require("../services/framework.service");
var base_directive_1 = require("./base.directive");
var OnKeyboard = /** @class */ (function (_super) {
    __extends(OnKeyboard, _super);
    function OnKeyboard(keyProcessor) {
        var _this = _super.call(this) || this;
        _this.keyProcessor = keyProcessor;
        _this.restrict = "A";
        return _this;
    }
    OnKeyboard_1 = OnKeyboard;
    OnKeyboard.prototype.create = function (scope, instanceElement, instanceAttributes, controller, transclude) {
        var _this = this;
        var keyActions = this.keyProcessor.parseActions(instanceAttributes["onKeyboard"]);
        if (keyActions.any(function (x) { return x.eventType === "keypress"; }))
            instanceElement.keypress(function (e) { return _this.keyProcessor.evaluateKeyActions(keyActions, "keypress", scope, e); });
        if (keyActions.any(function (x) { return x.eventType === "keydown"; }))
            instanceElement.keydown(function (e) { return _this.keyProcessor.evaluateKeyActions(keyActions, "keydown", scope, e); });
        if (keyActions.any(function (x) { return x.eventType === "keyup"; }))
            instanceElement.keyup(function (e) { return _this.keyProcessor.evaluateKeyActions(keyActions, "keyup", scope, e); });
    };
    OnKeyboard.factory = function (keyProcessor) {
        return new OnKeyboard_1(keyProcessor);
    };
    OnKeyboard = OnKeyboard_1 = __decorate([
        directive_1.Directive({
            name: "onKeyboard",
            factory: OnKeyboard_1.factory,
            dependencies: [framework_service_1.FrameworkServices.keyProcessorService]
        })
    ], OnKeyboard);
    return OnKeyboard;
    var OnKeyboard_1;
}(base_directive_1.DirectiveBase));
exports.OnKeyboard = OnKeyboard;
