"use strict";
/*!
 * MiracleDevs.Angular v1.0.0
 * Copyright (c) 2017 Miracle Devs, Inc
 * Licensed under MIT (https://github.com/MiracleDevs/MiracleDevs.Angular/blob/master/LICENSE)
 */
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
Object.defineProperty(exports, "__esModule", { value: true });
var directive_1 = require("../decorators/directive");
var base_directive_1 = require("./base.directive");
var ScrollToggleClass = /** @class */ (function (_super) {
    __extends(ScrollToggleClass, _super);
    function ScrollToggleClass() {
        var _this = _super !== null && _super.apply(this, arguments) || this;
        _this.restrict = "A";
        return _this;
    }
    ScrollToggleClass_1 = ScrollToggleClass;
    ScrollToggleClass.prototype.create = function (scope, instanceElement, instanceAttributes, controller, transclude) {
        var self = this;
        function updateElement() {
            self.updateElement(instanceElement, instanceAttributes);
        }
        $(window).on("scroll.scrollToggleClass", updateElement);
        this.updateElement(instanceElement, instanceAttributes);
    };
    ScrollToggleClass.prototype.updateElement = function (element, instanceAttributes) {
        var options = {};
        this.tryGetNumber(options, instanceAttributes, "minPos");
        this.tryGetNumber(options, instanceAttributes, "maxPos");
        this.tryGet(options, instanceAttributes, "cssClass");
        options.minPos = options.minPos || Number.MIN_VALUE;
        options.maxPos = options.maxPos || Number.MAX_VALUE;
        var scroll = $(window).scrollTop();
        if (scroll >= options.minPos && scroll <= options.maxPos)
            element.addClass(options.cssClass);
        else
            element.removeClass(options.cssClass);
    };
    ScrollToggleClass.prototype.dispose = function (scope, instanceElement, instanceAttributes, controller, transclude) {
        $(window).unbind("scroll.scrollToggleClass");
        _super.prototype.dispose.call(this, scope, instanceElement, instanceAttributes, controller, transclude);
    };
    ScrollToggleClass.factory = function () {
        return new ScrollToggleClass_1();
    };
    ScrollToggleClass = ScrollToggleClass_1 = __decorate([
        directive_1.Directive({
            name: "scrollToggleClass",
            factory: ScrollToggleClass_1.factory
        })
    ], ScrollToggleClass);
    return ScrollToggleClass;
    var ScrollToggleClass_1;
}(base_directive_1.DirectiveBase));
exports.ScrollToggleClass = ScrollToggleClass;
