/// <reference types="angular" />
/*!
 * MiracleDevs.Angular v1.0.0
 * Copyright (c) 2017 Miracle Devs, Inc
 * Licensed under MIT (https://github.com/MiracleDevs/MiracleDevs.Angular/blob/master/LICENSE)
 */
import { DirectiveBase } from "./base.directive";
import { IScope, IAttributes, ITranscludeFunction, IController } from "angular";
export declare class Tooltip extends DirectiveBase {
    restrict: string;
    scope: {
        tooltipOptions: string;
        tooltipCose: string;
        tooltipParameter: string;
    };
    protected create(scope: IScope, instanceElement: JQuery, instanceAttributes: IAttributes, controller: IController, transclude: ITranscludeFunction): void;
    private normalTooltip(control, scope, instanceAttributes);
    static factory(): Tooltip;
}
export interface ITooltipOptions {
    animation: "fade" | "grow" | "swing" | "slide" | "fall";
    animationDuration: number | number[];
    arrow: boolean;
    content: string | JQuery | any;
    contentAsHTML: boolean;
    contentCloning: boolean;
    debug: boolean;
    delay: number | number[];
    delayTouch: number | number[];
    distance: number | number[];
    IEmin: number;
    interactive: boolean;
    maxWidth: number;
    minIntersection: number;
    minWidth: number;
    multiple: boolean;
    plugins: string[];
    repositionOnScroll: boolean;
    restoration: "none" | "previous" | "current";
    selfDestruction: boolean;
    side: string | string[];
    timer: number;
    theme: string | string[];
    trackerInterval: number;
    trackOrigin: boolean;
    trackTooltip: boolean;
    trigger: "hover" | "click" | "custom";
    triggerClose: any;
    triggerOpen: any;
    updateAnimation: "fade" | "rotate" | "scale";
    viewportAware: boolean;
    zIndex: number;
}
