"use strict";
/*!
 * MiracleDevs.Angular v1.0.0
 * Copyright (c) 2017 Miracle Devs, Inc
 * Licensed under MIT (https://github.com/MiracleDevs/MiracleDevs.Angular/blob/master/LICENSE)
 */
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
Object.defineProperty(exports, "__esModule", { value: true });
var directive_1 = require("../decorators/directive");
var base_directive_1 = require("./base.directive");
var paradigm_ui_web_shared_1 = require("@miracledevs/paradigm-ui-web-shared");
var Tooltip = /** @class */ (function (_super) {
    __extends(Tooltip, _super);
    function Tooltip() {
        var _this = _super !== null && _super.apply(this, arguments) || this;
        _this.restrict = "A";
        _this.scope = {
            tooltipOptions: "@",
            tooltipCose: "&",
            tooltipParameter: "="
        };
        return _this;
    }
    Tooltip_1 = Tooltip;
    Tooltip.prototype.create = function (scope, instanceElement, instanceAttributes, controller, transclude) {
        var options = this.getOptions(instanceAttributes, "tooltipsterOptions");
        if (paradigm_ui_web_shared_1.ObjectExtensions.isNull(options) || paradigm_ui_web_shared_1.ObjectExtensions.isNull(options.content)) {
            this.normalTooltip(instanceElement, scope, instanceAttributes);
        }
        instanceElement.tooltipster(options);
    };
    Tooltip.prototype.normalTooltip = function (control, scope, instanceAttributes) {
        scope.$watch(function () { return instanceAttributes["title"]; }, function (newValue) {
            if (paradigm_ui_web_shared_1.StringExtensions.isNullOrWhiteSpace(newValue))
                return;
            var tooltipsterData = control.data("tooltipster-ns");
            if (!paradigm_ui_web_shared_1.ObjectExtensions.isNull(tooltipsterData)) {
                control.removeAttr("title");
                control.tooltipster("content", newValue);
            }
        });
    };
    Tooltip.factory = function () {
        return new Tooltip_1();
    };
    Tooltip = Tooltip_1 = __decorate([
        directive_1.Directive({
            name: "tooltip",
            factory: Tooltip_1.factory
        })
    ], Tooltip);
    return Tooltip;
    var Tooltip_1;
}(base_directive_1.DirectiveBase));
exports.Tooltip = Tooltip;
