"use strict";
/*!
 * MiracleDevs.Angular v1.0.0
 * Copyright (c) 2017 Miracle Devs, Inc
 * Licensed under MIT (https://github.com/MiracleDevs/MiracleDevs.Angular/blob/master/LICENSE)
 */
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
Object.defineProperty(exports, "__esModule", { value: true });
var base_module_1 = require("./base.module");
var add_class_directive_1 = require("./directives/add-class.directive");
var alert_directive_1 = require("./directives/alert.directive");
var background_image_directive_1 = require("./directives/background-image.directive");
var comment_area_directive_1 = require("./directives/comment-area.directive");
var convert_to_number_directive_1 = require("./directives/convert-to-number.directive");
var date_time_picker_directive_1 = require("./directives/date-time-picker.directive");
var file_button_directive_1 = require("./directives/file-button.directive");
var file_drag_and_drop_directive_1 = require("./directives/file-drag-and-drop.directive");
var focus_when_directive_1 = require("./directives/focus-when.directive");
var format_as_number_directive_1 = require("./directives/format-as-number.directive");
var full_select_directive_1 = require("./directives/full-select.directive");
var horizontal_scroller_directive_1 = require("./directives/horizontal-scroller.directive");
var keyboard_listener_directive_1 = require("./directives/keyboard-listener.directive");
var md_ui_sref_active_directive_1 = require("./directives/md-ui-sref-active.directive");
var on_keyboard_directive_1 = require("./directives/on-keyboard.directive");
var prevent_event_if_directive_1 = require("./directives/prevent-event-if.directive");
var remove_class_directive_1 = require("./directives/remove-class.directive");
var scroll_to_bottom_directive_1 = require("./directives/scroll-to-bottom.directive");
var scroll_toggle_class_directive_1 = require("./directives/scroll-toggle-class.directive");
var scroll_to_top_directive_1 = require("./directives/scroll-to-top.directive");
var select_toggle_class_directive_1 = require("./directives/select-toggle-class.directive");
var toggle_class_directive_1 = require("./directives/toggle-class.directive");
var toggle_class_on_click_directive_1 = require("./directives/toggle-class-on-click.directive");
var tooltip_directive_1 = require("./directives/tooltip.directive");
var alert_service_1 = require("./services/alert.service");
var async_resource_service_1 = require("./services/async-resource.service");
var date_service_1 = require("./services/date.service");
var exception_service_1 = require("./services/exception.service");
var file_management_service_1 = require("./services/file-management.service");
var geolocation_service_1 = require("./services/geolocation.service");
var key_processor_service_1 = require("./services/key-processor.service");
var message_bus_service_1 = require("./services/message-bus.service");
var modal_service_1 = require("./services/modal.service");
var logging_service_1 = require("./services/logging.service");
var url_service_1 = require("./services/url.service");
var FrameworkModule = /** @class */ (function (_super) {
    __extends(FrameworkModule, _super);
    function FrameworkModule() {
        var _this = this;
        if (FrameworkModule.internalInstance != null)
            throw new Error("The program does not allow more than one instance of the ModuleBase.");
        _this = _super.call(this) || this;
        FrameworkModule.internalInstance = _this;
        _this.logger.writeMessage("creating application");
        return _this;
    }
    Object.defineProperty(FrameworkModule, "instance", {
        get: function () { return FrameworkModule.internalInstance; },
        enumerable: true,
        configurable: true
    });
    FrameworkModule.prototype.getModuleName = function () {
        return "miracledevs-framework";
    };
    FrameworkModule.prototype.register = function () {
        _super.prototype.register.call(this);
        this.registerServices([
            alert_service_1.AlertService,
            async_resource_service_1.AsyncResourceService,
            date_service_1.DateService,
            exception_service_1.ExceptionService,
            file_management_service_1.FileManagementService,
            geolocation_service_1.GeolocationService,
            key_processor_service_1.KeyProcessorService,
            logging_service_1.LoggingService,
            message_bus_service_1.MessageBus,
            modal_service_1.ModalService,
            url_service_1.UrlService
        ]);
        this.registerDirectives([
            add_class_directive_1.AddClass,
            alert_directive_1.Alert,
            background_image_directive_1.BackgroundImage,
            comment_area_directive_1.CommentArea,
            convert_to_number_directive_1.ConvertToNumber,
            date_time_picker_directive_1.DateTimePicker,
            file_button_directive_1.FileButton,
            file_drag_and_drop_directive_1.FileDragAndDrop,
            focus_when_directive_1.FocusWhen,
            format_as_number_directive_1.FormatAsNumber,
            full_select_directive_1.FullSelect,
            horizontal_scroller_directive_1.HorizontalScroller,
            keyboard_listener_directive_1.KeyboardListener,
            md_ui_sref_active_directive_1.MdUiSrefActive,
            on_keyboard_directive_1.OnKeyboard,
            prevent_event_if_directive_1.PreventEventIf,
            remove_class_directive_1.RemoveClass,
            scroll_to_bottom_directive_1.ScrollToBottom,
            scroll_toggle_class_directive_1.ScrollToggleClass,
            scroll_to_top_directive_1.ScrollToTop,
            select_toggle_class_directive_1.SelectToggleClass,
            toggle_class_directive_1.ToggleClass,
            toggle_class_on_click_directive_1.ToggleClassOnClick,
            tooltip_directive_1.Tooltip
        ]);
    };
    FrameworkModule.prototype.configureRoutes = function (stateProvider, urlRouterProvider, httpProvider, location) {
    };
    FrameworkModule.prototype.authorizeRoute = function (rootScope, state, injector) {
    };
    FrameworkModule.prototype.getModuleDependencies = function () {
        return ["ui.router", "ngAnimate", "pascalprecht.translate"];
    };
    FrameworkModule.internalInstance = new FrameworkModule();
    return FrameworkModule;
}(base_module_1.ModuleBase));
exports.FrameworkModule = FrameworkModule;
