/*!
 * MiracleDevs.Angular v1.0.0
 * Copyright (c) 2017 Miracle Devs, Inc
 * Licensed under MIT (https://github.com/MiracleDevs/MiracleDevs.Angular/blob/master/LICENSE)
 */
import { ServiceBase } from "./base.service";
import { ArrayList } from "@miracledevs/paradigm-ui-web-shared";
import { IAlertService, Alert, AlertType } from "./alert.service.interface";
import { ILoggingService } from "./logging.service.interface";
export declare class AlertService extends ServiceBase implements IAlertService {
    private logger;
    private alerts;
    constructor(logger: ILoggingService);
    add(alertType: AlertType, message: string): void;
    addError(message: string): void;
    addWarning(message: string): void;
    addMessage(message: string): void;
    remove(index: number | Alert): void;
    get(index: number): Alert;
    getAlerts(): ArrayList<Alert>;
    static factory(logger: ILoggingService): IAlertService;
}
