/*!
 * MiracleDevs.Angular v1.0.0
 * Copyright (c) 2017 Miracle Devs, Inc
 * Licensed under MIT (https://github.com/MiracleDevs/MiracleDevs.Angular/blob/master/LICENSE)
 */
import { ArrayList } from "@miracledevs/paradigm-ui-web-shared";
export interface IAlertService {
    add(alertType: AlertType, message: string): void;
    addError(message: string): void;
    addWarning(message: string): void;
    addMessage(message: string): void;
    remove(index: number | Alert): void;
    get(index: number): Alert;
    getAlerts(): ArrayList<Alert>;
}
export declare enum AlertType {
    Message = 0,
    Warning = 1,
    Error = 2,
}
export declare class Alert {
    private alertType;
    private innerMessage;
    readonly type: AlertType;
    readonly typeName: string;
    readonly message: string;
    constructor(alertType: AlertType, message: string);
    private static getTypeName(alertType);
}
