"use strict";
/*!
 * MiracleDevs.Angular v1.0.0
 * Copyright (c) 2017 Miracle Devs, Inc
 * Licensed under MIT (https://github.com/MiracleDevs/MiracleDevs.Angular/blob/master/LICENSE)
 */
Object.defineProperty(exports, "__esModule", { value: true });
var AlertType;
(function (AlertType) {
    AlertType[AlertType["Message"] = 0] = "Message";
    AlertType[AlertType["Warning"] = 1] = "Warning";
    AlertType[AlertType["Error"] = 2] = "Error";
})(AlertType = exports.AlertType || (exports.AlertType = {}));
var Alert = /** @class */ (function () {
    function Alert(alertType, message) {
        this.alertType = alertType;
        this.innerMessage = message;
    }
    Object.defineProperty(Alert.prototype, "type", {
        get: function () { return this.alertType; },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(Alert.prototype, "typeName", {
        get: function () { return Alert.getTypeName(this.alertType); },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(Alert.prototype, "message", {
        get: function () { return this.innerMessage; },
        enumerable: true,
        configurable: true
    });
    Alert.getTypeName = function (alertType) {
        switch (alertType) {
            case AlertType.Message:
                return "message";
            case AlertType.Warning:
                return "warning";
            case AlertType.Error:
                return "error";
            default:
                return "unknown";
        }
    };
    return Alert;
}());
exports.Alert = Alert;
