"use strict";
/*!
 * MiracleDevs.Angular v1.0.0
 * Copyright (c) 2017 Miracle Devs, Inc
 * Licensed under MIT (https://github.com/MiracleDevs/MiracleDevs.Angular/blob/master/LICENSE)
 */
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
Object.defineProperty(exports, "__esModule", { value: true });
var base_service_1 = require("./base.service");
var service_1 = require("../decorators/service");
var paradigm_ui_web_shared_1 = require("@miracledevs/paradigm-ui-web-shared");
var framework_service_1 = require("./framework.service");
var alert_service_interface_1 = require("./alert.service.interface");
var AlertService = /** @class */ (function (_super) {
    __extends(AlertService, _super);
    function AlertService(logger) {
        var _this = _super.call(this) || this;
        _this.logger = logger;
        _this.alerts = new paradigm_ui_web_shared_1.ArrayList();
        return _this;
    }
    AlertService_1 = AlertService;
    AlertService.prototype.add = function (alertType, message) {
        this.alerts.add(new alert_service_interface_1.Alert(alertType, message));
    };
    AlertService.prototype.addError = function (message) {
        this.add(alert_service_interface_1.AlertType.Error, message);
        this.logger.writeError(message);
    };
    AlertService.prototype.addWarning = function (message) {
        this.add(alert_service_interface_1.AlertType.Warning, message);
        this.logger.writeWarning(message);
    };
    AlertService.prototype.addMessage = function (message) {
        this.add(alert_service_interface_1.AlertType.Message, message);
        this.logger.writeMessage(message);
    };
    AlertService.prototype.remove = function (index) {
        if (index instanceof alert_service_interface_1.Alert)
            this.alerts.remove(index);
        else
            this.alerts.removeAt(index);
    };
    AlertService.prototype.get = function (index) {
        return this.alerts.get(index);
    };
    AlertService.prototype.getAlerts = function () {
        return this.alerts;
    };
    AlertService.factory = function (logger) {
        return new AlertService_1(logger);
    };
    AlertService = AlertService_1 = __decorate([
        service_1.Service({
            name: framework_service_1.FrameworkServices.alertService,
            factory: AlertService_1.factory,
            dependencies: [framework_service_1.FrameworkServices.loggingService]
        })
    ], AlertService);
    return AlertService;
    var AlertService_1;
}(base_service_1.ServiceBase));
exports.AlertService = AlertService;
