/// <reference types="angular" />
import { ServiceBase } from "./base.service";
import { ISCEService, IQService, IDocumentService, IPromise } from "angular";
import { IAsyncResourceService } from "./async-resource.service.interface";
export declare class AsyncResourceService extends ServiceBase implements IAsyncResourceService {
    private sce;
    private q;
    private document;
    private readonly deferredRequests;
    constructor(sce: ISCEService, q: IQService, document: IDocumentService);
    loadScript(url: string): IPromise<void>;
    loadImage(url: string): IPromise<void>;
    loadVieo(url: string): IPromise<void>;
    private loadResource(type, url);
    static factory(sce: ISCEService, q: IQService, document: IDocumentService): IAsyncResourceService;
}
