"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
Object.defineProperty(exports, "__esModule", { value: true });
/*!
 * MiracleDevs.Angular v1.0.0
 * Copyright (c) 2017 Miracle Devs, Inc
 * Licensed under MIT (https://github.com/MiracleDevs/MiracleDevs.Angular/blob/master/LICENSE)
 */
var base_service_1 = require("./base.service");
var service_1 = require("../decorators/service");
var framework_service_1 = require("./framework.service");
var angular_service_1 = require("./angular.service");
var paradigm_ui_web_shared_1 = require("@miracledevs/paradigm-ui-web-shared");
var angular = require("angular");
var AsyncResourceService = /** @class */ (function (_super) {
    __extends(AsyncResourceService, _super);
    function AsyncResourceService(sce, q, document) {
        var _this = _super.call(this) || this;
        _this.sce = sce;
        _this.q = q;
        _this.document = document;
        _this.deferredRequests = new paradigm_ui_web_shared_1.Dictionary();
        return _this;
    }
    AsyncResourceService_1 = AsyncResourceService;
    AsyncResourceService.prototype.loadScript = function (url) {
        return this.loadResource("script", url);
    };
    AsyncResourceService.prototype.loadImage = function (url) {
        return this.loadResource("img", url);
    };
    AsyncResourceService.prototype.loadVieo = function (url) {
        return this.loadResource("video", url);
    };
    AsyncResourceService.prototype.loadResource = function (type, url) {
        if (this.deferredRequests.containsKey(url))
            return this.deferredRequests.get(url).promise;
        var defer = this.q.defer();
        this.deferredRequests.add(url, defer);
        this.sce.trustAsResourceUrl(url);
        var element = angular.element("<" + type + "></" + type + ">");
        this.document.find("body").append(element);
        element.on("load", function () { return defer.resolve(); });
        element.attr("id", "async script");
        element[0]["src"] = url;
        return defer.promise;
    };
    AsyncResourceService.factory = function (sce, q, document) {
        return new AsyncResourceService_1(sce, q, document);
    };
    AsyncResourceService = AsyncResourceService_1 = __decorate([
        service_1.Service({
            name: framework_service_1.FrameworkServices.asyncResourceService,
            factory: AsyncResourceService_1.factory,
            dependencies: [angular_service_1.AngularServices.sce, angular_service_1.AngularServices.q, angular_service_1.AngularServices.document]
        })
    ], AsyncResourceService);
    return AsyncResourceService;
    var AsyncResourceService_1;
}(base_service_1.ServiceBase));
exports.AsyncResourceService = AsyncResourceService;
