"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
Object.defineProperty(exports, "__esModule", { value: true });
/*!
 * MiracleDevs.Angular v1.0.0
 * Copyright (c) 2017 Miracle Devs, Inc
 * Licensed under MIT (https://github.com/MiracleDevs/MiracleDevs.Angular/blob/master/LICENSE)
 */
var service_1 = require("../decorators/service");
var base_service_1 = require("./base.service");
var framework_service_1 = require("./framework.service");
var paradigm_ui_web_shared_1 = require("@miracledevs/paradigm-ui-web-shared");
var date_service_interface_1 = require("./date.service.interface");
var DateService = /** @class */ (function (_super) {
    __extends(DateService, _super);
    function DateService() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    DateService_1 = DateService;
    DateService.prototype.getDate = function (value) {
        if (value instanceof Date)
            return value;
        var date = new Date();
        if (paradigm_ui_web_shared_1.StringExtensions.isString(value))
            date = new Date(value);
        if (paradigm_ui_web_shared_1.ObjectExtensions.isNull(date) || isNaN(date.getTime())) {
            date = paradigm_ui_web_shared_1.DateExtensions.fromIso8601(value);
        }
        return date;
    };
    DateService.prototype.getDateRangeValue = function (value) {
        var oneSecond = 1000;
        var oneMinute = oneSecond * 60;
        var oneHour = oneMinute * 60;
        var oneDay = oneHour * 24;
        var oneYear = 12;
        var now = new Date(Date.now());
        var nowMiliseconds = now.getMilliseconds();
        var nowSeconds = now.getSeconds();
        var nowMinutes = now.getMinutes();
        var nowHours = now.getHours();
        var nowDays = now.getDate();
        var nowMonths = now.getMonth();
        var nowYears = now.getFullYear();
        // var oneSecondAgo = new Date(nowYears, nowMonths, nowDays, nowHours, nowMinutes, nowSeconds - 1, nowMiliseconds);
        var oneMinuteAgo = new Date(nowYears, nowMonths, nowDays, nowHours, nowMinutes - 1, nowSeconds, nowMiliseconds);
        var oneHourAgo = new Date(nowYears, nowMonths, nowDays, nowHours - 1, nowMinutes, nowSeconds, nowMiliseconds);
        var oneDayAgo = new Date(nowYears, nowMonths, nowDays - 1, nowHours, nowMinutes, nowSeconds, nowMiliseconds);
        var oneMonthAgo = new Date(nowYears, nowMonths - 1, nowDays, nowHours, nowMinutes, nowSeconds, nowMiliseconds);
        var oneYearAgo = new Date(nowYears - 1, nowMonths, nowDays, nowHours, nowMinutes, nowSeconds, nowMiliseconds);
        if (paradigm_ui_web_shared_1.ObjectExtensions.isNull(value))
            return new date_service_interface_1.DateRangeValue(0, date_service_interface_1.DateRange.Unknown);
        var date = this.getDate(value);
        var rangeSeconds = Math.floor((now.valueOf() - date.valueOf()) / oneSecond);
        var rangeMinutes = Math.floor((now.valueOf() - date.valueOf()) / oneMinute);
        var rangeHours = Math.floor((now.valueOf() - date.valueOf()) / oneHour);
        var rangeDays = Math.floor((now.valueOf() - date.valueOf()) / oneDay);
        var rangeMonths = this.getMonthDifference(date, now);
        var rangeYears = Math.floor(rangeMonths / oneYear);
        if (date > oneMinuteAgo) {
            return new date_service_interface_1.DateRangeValue(rangeSeconds, date_service_interface_1.DateRange.Seconds);
        }
        else if (date > oneHourAgo && date <= oneMinuteAgo) {
            return new date_service_interface_1.DateRangeValue(rangeMinutes, date_service_interface_1.DateRange.Minutes);
        }
        if (date > oneDayAgo && date <= oneHourAgo) {
            return new date_service_interface_1.DateRangeValue(rangeHours, date_service_interface_1.DateRange.Hours);
        }
        else if (date > oneMonthAgo && date <= oneDayAgo) {
            return new date_service_interface_1.DateRangeValue(rangeDays, date_service_interface_1.DateRange.Days);
        }
        else if (date > oneYearAgo && date <= oneMonthAgo) {
            return new date_service_interface_1.DateRangeValue(rangeMonths, date_service_interface_1.DateRange.Months);
        }
        return new date_service_interface_1.DateRangeValue(rangeYears, date_service_interface_1.DateRange.Years);
    };
    DateService.prototype.getMonthDifference = function (d1, d2) {
        var months;
        months = (d2.getFullYear() - d1.getFullYear()) * 12;
        months -= d1.getMonth();
        months += d2.getMonth();
        return months <= 0 ? 0 : months;
    };
    DateService.factory = function () {
        return new DateService_1();
    };
    DateService = DateService_1 = __decorate([
        service_1.Service({
            name: framework_service_1.FrameworkServices.dateService,
            factory: DateService_1.factory
        })
    ], DateService);
    return DateService;
    var DateService_1;
}(base_service_1.ServiceBase));
exports.DateService = DateService;
