"use strict";
/*!
 * MiracleDevs.Angular v1.0.0
 * Copyright (c) 2017 Miracle Devs, Inc
 * Licensed under MIT (https://github.com/MiracleDevs/MiracleDevs.Angular/blob/master/LICENSE)
 */
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
Object.defineProperty(exports, "__esModule", { value: true });
var service_1 = require("../decorators/service");
var base_service_1 = require("./base.service");
var framework_service_1 = require("./framework.service");
var angular_service_1 = require("./angular.service");
var paradigm_ui_web_shared_1 = require("@miracledevs/paradigm-ui-web-shared");
var FileManagementService = /** @class */ (function (_super) {
    __extends(FileManagementService, _super);
    function FileManagementService(timeout) {
        var _this = _super.call(this) || this;
        _this.timeout = timeout;
        return _this;
    }
    FileManagementService_1 = FileManagementService;
    FileManagementService.prototype.read = function (file, completed, progress, error) {
        var _this = this;
        var reader = new FileReader();
        reader.onload = function (e) { return _this.timeout(function () { return completed(file, btoa(e.target["result"])); }); };
        if (!paradigm_ui_web_shared_1.ObjectExtensions.isNull(progress))
            reader.onprogress = function (e) {
                if (e.lengthComputable) {
                    var percentLoaded = Math.round((e.loaded / e.total) * 100);
                    progress(percentLoaded);
                }
            };
        if (!paradigm_ui_web_shared_1.ObjectExtensions.isNull(error)) {
            reader.onabort = function (e) { return error(_this.getError(e)); };
            reader.onerror = function (e) { return error(_this.getError(e)); };
        }
        reader.readAsBinaryString(file);
    };
    FileManagementService.prototype.download = function (fileName, content) {
        var a = window.document.createElement("a");
        a.href = window.URL.createObjectURL(this.getBlob(fileName, content));
        a.download = fileName;
        document.body.appendChild(a);
        a.click();
        document.body.removeChild(a);
    };
    FileManagementService.prototype.open = function (fileName, content) {
        var blob = this.getBlob(fileName, content);
        if (window.navigator && window.navigator.msSaveOrOpenBlob) {
            window.navigator.msSaveOrOpenBlob(blob, fileName);
        }
        else {
            var url = window.URL.createObjectURL(blob);
            window.open(url);
        }
    };
    FileManagementService.prototype.getBlobUrl = function (fileName, content) {
        return window.URL.createObjectURL(this.getBlob(fileName, content));
    };
    FileManagementService.prototype.getBlob = function (fileName, content64) {
        var content = atob(content64);
        var byteArray = new Uint8Array(content.length);
        for (var i = 0; i < byteArray.length; i++)
            byteArray[i] = content.charCodeAt(i);
        return new Blob([byteArray], { type: paradigm_ui_web_shared_1.fileMimeType.get(fileName) });
    };
    FileManagementService.prototype.getError = function (e) {
        switch (e.target["error"].code) {
            case e.target["error"].NOT_FOUND_ERR:
                return "File not found.";
            case e.target["error"].NOT_READABLE_ERR:
                return "File is not readable.";
            case e.target["error"].ABORT_ERR:
                return "Read operation was aborted.";
            case e.target["error"].SECURITY_ERR:
                return "File is in a locked state.";
            case e.target["error"].ENCODING_ERR:
                return "The file is too long to encode.";
            default:
                return "Can not read the file.";
        }
    };
    FileManagementService.factory = function (timeout) {
        return new FileManagementService_1(timeout);
    };
    FileManagementService = FileManagementService_1 = __decorate([
        service_1.Service({
            name: framework_service_1.FrameworkServices.fileManagementService,
            factory: FileManagementService_1.factory,
            dependencies: [angular_service_1.AngularServices.timeout]
        })
    ], FileManagementService);
    return FileManagementService;
    var FileManagementService_1;
}(base_service_1.ServiceBase));
exports.FileManagementService = FileManagementService;
