"use strict";
/*!
 * MiracleDevs.Angular v1.0.0
 * Copyright (c) 2017 Miracle Devs, Inc
 * Licensed under MIT (https://github.com/MiracleDevs/MiracleDevs.Angular/blob/master/LICENSE)
 */
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
Object.defineProperty(exports, "__esModule", { value: true });
var service_1 = require("../decorators/service");
var framework_service_1 = require("./framework.service");
var base_service_1 = require("./base.service");
var paradigm_ui_web_shared_1 = require("@miracledevs/paradigm-ui-web-shared");
var GeolocationService = /** @class */ (function (_super) {
    __extends(GeolocationService, _super);
    function GeolocationService() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    GeolocationService_1 = GeolocationService;
    GeolocationService.prototype.getPosition = function (callback, onError, options) {
        if (!this.isAvailable())
            return;
        this.getGeolocator().getCurrentPosition(callback, onError, options);
    };
    GeolocationService.prototype.watchPosition = function (callback, onError, options) {
        if (!this.isAvailable())
            return -1;
        return this.getGeolocator().watchPosition(callback, onError, options);
    };
    GeolocationService.prototype.clearWatch = function (watchId) {
        if (!this.isAvailable())
            return;
        this.getGeolocator().clearWatch(watchId);
    };
    GeolocationService.prototype.isAvailable = function () {
        return !paradigm_ui_web_shared_1.ObjectExtensions.isNull(navigator.geolocation);
    };
    GeolocationService.prototype.getGeolocator = function () {
        return navigator.geolocation;
    };
    GeolocationService.factory = function () {
        return new GeolocationService_1();
    };
    GeolocationService = GeolocationService_1 = __decorate([
        service_1.Service({
            name: framework_service_1.FrameworkServices.geolocationService,
            factory: GeolocationService_1.factory
        })
    ], GeolocationService);
    return GeolocationService;
    var GeolocationService_1;
}(base_service_1.ServiceBase));
exports.GeolocationService = GeolocationService;
