"use strict";
/*!
 * MiracleDevs.Angular v1.0.0
 * Copyright (c) 2017 Miracle Devs, Inc
 * Licensed under MIT (https://github.com/MiracleDevs/MiracleDevs.Angular/blob/master/LICENSE)
 */
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
Object.defineProperty(exports, "__esModule", { value: true });
var base_service_1 = require("./base.service");
var paradigm_ui_web_shared_1 = require("@miracledevs/paradigm-ui-web-shared");
var HttpServiceBase = /** @class */ (function (_super) {
    __extends(HttpServiceBase, _super);
    function HttpServiceBase($http, host) {
        var _this = _super.call(this) || this;
        _this.$http = $http;
        _this.host = host;
        return _this;
    }
    HttpServiceBase.prototype.getStringValue = function (value) {
        if (paradigm_ui_web_shared_1.ObjectExtensions.isNull(value))
            return "";
        if (paradigm_ui_web_shared_1.ObjectExtensions.getTypeName(value) === "Number" ||
            paradigm_ui_web_shared_1.ObjectExtensions.getTypeName(value) === "String" ||
            paradigm_ui_web_shared_1.ObjectExtensions.getTypeName(value) === "Boolean") {
            return value.toString();
        }
        if (paradigm_ui_web_shared_1.ObjectExtensions.getTypeName(value) === "Date") {
            return paradigm_ui_web_shared_1.DateExtensions.formatUTC(value, "yyyy-MM-ddThh:mm:ss.fff");
        }
        return "";
    };
    HttpServiceBase.prototype.getUrl = function (url, params) {
        if (!paradigm_ui_web_shared_1.ObjectExtensions.isNull(params)) {
            for (var key in params) {
                if (params.hasOwnProperty(key)) {
                    url = url.replace("{" + key + "}", this.getStringValue(params[key]));
                }
            }
        }
        return "" + this.host + url;
    };
    HttpServiceBase.prototype.post = function (url, params, data, queryString) {
        return this.$http.post(this.getUrl(url, params), data, { headers: this.getHeaders(), params: queryString });
    };
    HttpServiceBase.prototype.patch = function (url, params, data, queryString) {
        return this.$http.patch(this.getUrl(url, params), data, { headers: this.getHeaders(), params: queryString });
    };
    HttpServiceBase.prototype.put = function (url, params, data, queryString) {
        return this.$http.put(this.getUrl(url, params), data, { headers: this.getHeaders(), params: queryString });
    };
    HttpServiceBase.prototype.get = function (url, params, data, queryString) {
        return this.$http.get(this.getUrl(url, params), { headers: this.getHeaders(), params: queryString });
    };
    HttpServiceBase.prototype.delete = function (url, params, data, queryString) {
        return this.$http.delete(this.getUrl(url, params), { headers: this.getHeaders(), params: queryString });
    };
    HttpServiceBase.prototype.getHeaders = function () {
        return { "Content-Type": "application/json; charset=utf-8" };
    };
    return HttpServiceBase;
}(base_service_1.ServiceBase));
exports.HttpServiceBase = HttpServiceBase;
