"use strict";
/*!
 * MiracleDevs.Angular v1.0.0
 * Copyright (c) 2017 Miracle Devs, Inc
 * Licensed under MIT (https://github.com/MiracleDevs/MiracleDevs.Angular/blob/master/LICENSE)
 */
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
Object.defineProperty(exports, "__esModule", { value: true });
var base_service_1 = require("./base.service");
var paradigm_ui_web_shared_1 = require("@miracledevs/paradigm-ui-web-shared");
var service_1 = require("../decorators/service");
var framework_service_1 = require("./framework.service");
var LoggingServiceBase = /** @class */ (function (_super) {
    __extends(LoggingServiceBase, _super);
    function LoggingServiceBase() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    LoggingServiceBase.prototype.writeMessage = function (message) { };
    LoggingServiceBase.prototype.writeWarning = function (message) { };
    LoggingServiceBase.prototype.writeError = function (message) { };
    LoggingServiceBase.prototype.getString = function (message) {
        return "[" + paradigm_ui_web_shared_1.DateExtensions.format(new Date(), "MM/dd/yy hh:mm:ss.fff") + "] - " + message;
    };
    return LoggingServiceBase;
}(base_service_1.ServiceBase));
exports.LoggingServiceBase = LoggingServiceBase;
var DummyLoggingService = /** @class */ (function (_super) {
    __extends(DummyLoggingService, _super);
    function DummyLoggingService() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    DummyLoggingService_1 = DummyLoggingService;
    DummyLoggingService.prototype.writeError = function (message) { console.error(this.getString(message)); };
    DummyLoggingService.factory = function () {
        return new LoggingService();
    };
    DummyLoggingService = DummyLoggingService_1 = __decorate([
        service_1.Service({
            name: framework_service_1.FrameworkServices.loggingService,
            factory: DummyLoggingService_1.factory
        })
    ], DummyLoggingService);
    return DummyLoggingService;
    var DummyLoggingService_1;
}(LoggingServiceBase));
exports.DummyLoggingService = DummyLoggingService;
var LoggingService = /** @class */ (function (_super) {
    __extends(LoggingService, _super);
    function LoggingService() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    LoggingService_1 = LoggingService;
    LoggingService.prototype.writeMessage = function (message) {
        console.info(this.getString(message));
    };
    LoggingService.prototype.writeWarning = function (message) {
        console.warn(this.getString(message));
    };
    LoggingService.prototype.writeError = function (message) {
        console.error(this.getString(message));
    };
    LoggingService.factory = function () {
        return new LoggingService_1();
    };
    LoggingService = LoggingService_1 = __decorate([
        service_1.Service({
            name: framework_service_1.FrameworkServices.loggingService,
            factory: LoggingService_1.factory
        })
    ], LoggingService);
    return LoggingService;
    var LoggingService_1;
}(LoggingServiceBase));
exports.LoggingService = LoggingService;
