/*!
 * MiracleDevs.Angular v1.0.0
 * Copyright (c) 2017 Miracle Devs, Inc
 * Licensed under MIT (https://github.com/MiracleDevs/MiracleDevs.Angular/blob/master/LICENSE)
 */
import { ServiceBase } from "./base.service";
import { IMessageBus, MessageBusHandler, RegistrationToken } from "./message-bus.service.interface";
import { Dictionary, ArrayList } from "@miracledevs/paradigm-ui-web-shared";
export declare class MessageBus extends ServiceBase implements IMessageBus {
    handlers: Dictionary<string, ArrayList<MessageBusHandler>>;
    constructor();
    register<T>(messageType: {
        new (): T;
    }, handler: Function): RegistrationToken;
    unregister(token: RegistrationToken): void;
    send<T>(messageType: {
        new (): T;
    }, message: T, token?: RegistrationToken): boolean;
    static factory(): MessageBus;
}
