/*!
 * MiracleDevs.Angular v1.0.0
 * Copyright (c) 2017 Miracle Devs, Inc
 * Licensed under MIT (https://github.com/MiracleDevs/MiracleDevs.Angular/blob/master/LICENSE)
 */
import { Dictionary, ArrayList, Guid } from "@miracledevs/paradigm-ui-web-shared";
export interface IMessageBus {
    handlers: Dictionary<string, ArrayList<MessageBusHandler>>;
    register<T>(messageType: {
        new (): T;
    }, handler: Function): RegistrationToken;
    unregister(token: RegistrationToken): void;
    send<T>(messageType: {
        new (): T;
    }, message: T, token?: RegistrationToken): boolean;
}
export declare class MessageBusHandler {
    private innerToken;
    private innerHandler;
    readonly token: RegistrationToken;
    readonly handler: Function;
    constructor(type: Function, handler: Function);
}
export declare class RegistrationToken {
    private innerType;
    private innerGuid;
    readonly type: Function;
    readonly guid: Guid;
    constructor(type: Function);
}
