/// <reference types="angular" />
/// <reference types="angular-mocks" />
/*!
 * MiracleDevs.Angular v1.0.0
 * Copyright (c) 2017 Miracle Devs, Inc
 * Licensed under MIT (https://github.com/MiracleDevs/MiracleDevs.Angular/blob/master/LICENSE)
 */
import { ServiceBase } from "./base.service";
import { IModalService, IModalInstance, IModalCreationParameter } from "./modal.service.interface";
import { Dictionary } from "@miracledevs/paradigm-ui-web-shared";
export declare class ModalService extends ServiceBase implements IModalService {
    private $rootScope;
    private $q;
    private $http;
    private $templateCache;
    private $compile;
    private $controller;
    readonly modals: Dictionary<IModalInstance, ng.IAugmentedJQuery>;
    constructor($rootScope: ng.IRootScopeService, $q: ng.IQService, $http: ng.IHttpService, $templateCache: ng.ITemplateCacheService, $compile: ng.ICompileService, $controller: ng.IControllerService);
    open(dialog: IModalCreationParameter, parameters?: any, staticDialog?: boolean, keyboard?: boolean): IModalInstance;
    close(modalInstance: IModalInstance, reason?: string): void;
    resolve<T>(modalInstance: IModalInstance, result: T): void;
    private openModal(register, controllerAs, parameters, modalInstance, template, staticDialog, keyboard);
    private removeModal(modalInstance, modal);
    static factory($rootScope: ng.IRootScopeService, $q: ng.IQService, $http: ng.IHttpService, $templateCache: ng.ITemplateCacheService, $compile: ng.ICompileService, $controller: ng.IControllerService): ModalService;
}
export declare class ModalInstance implements IModalInstance {
    private readonly modalService;
    deferred: ng.IDeferred<any>;
    promise: ng.IPromise<any>;
    dispose: () => void;
    constructor(modalService: IModalService, deferred: ng.IDeferred<any>);
    close(reason?: string): void;
    resolve(result: any): void;
}
