/// <reference types="angular" />
/*!
 * MiracleDevs.Angular v1.0.0
 * Copyright (c) 2017 Miracle Devs, Inc
 * Licensed under MIT (https://github.com/MiracleDevs/MiracleDevs.Angular/blob/master/LICENSE)
 */
import { Dictionary } from "@miracledevs/paradigm-ui-web-shared";
import { IController } from "../decorators/controller";
import { IDeferred, IPromise } from "angular";
export interface IModalService {
    readonly modals: Dictionary<IModalInstance, ng.IAugmentedJQuery>;
    open<T>(dialog: IModalCreationParameter, parameters?: any, staticDialog?: boolean, keyboard?: boolean): IModalInstance;
    open<T>(dialog: any, parameters?: any, staticDialog?: boolean, keyboard?: boolean): IModalInstance;
    close(modalInstance: any, reason?: string): any;
    resolve<T>(modalInstance: any, result: T): any;
}
export interface IModalCreationParameter {
    register: IController;
    controllerAs?: string;
}
export interface IModalInstance {
    deferred: IDeferred<any>;
    promise: IPromise<any>;
    close(reason?: string): any;
    resolve(result: any): any;
    dispose: () => void;
}
